# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from cob_light/SetLightModeRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import cob_light.msg
import std_msgs.msg

class SetLightModeRequest(genpy.Message):
  _md5sum = "cf64533ba011e7f531cecce5a35c9b83"
  _type = "cob_light/SetLightModeRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """cob_light/LightMode mode

================================================================================
MSG: cob_light/LightMode
uint8 mode                         # mode to switch on

float32                frequency   # in Hz
float32                timeout     # in s, requested mode will be executed for max timeout s.
                                   # default is 0 and means no timeout.
int32                  pulses      # specifies the amount of pulses which will be executed.
                                   # eg: mode = flash, pulses = 2. Means the light will flash two times
int8                   priority    # priority [-20,20] default = 0. Modes with same or higher priorities will
                                   # be executed.
std_msgs/ColorRGBA[]   colors      # array of colors.
                                   # size > 1: each color represent one led (size should match the amount of leds)
                                   # size = 1: one color for all leds or color for specific mode
                                   # size = 0: undefined
cob_light/Sequence[]   sequences   # an array of sequence definitions, used only if mode is set to SEQ

================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

================================================================================
MSG: cob_light/Sequence
std_msgs/ColorRGBA   color       #sequence color
float32              hold_time   #time how long the color should be hold [s]
float32              cross_time  #time how long it take to fade to this color [s]"""
  __slots__ = ['mode']
  _slot_types = ['cob_light/LightMode']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       mode

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SetLightModeRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.mode is None:
        self.mode = cob_light.msg.LightMode()
    else:
      self.mode = cob_light.msg.LightMode()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_B2fib().pack(_x.mode.mode, _x.mode.frequency, _x.mode.timeout, _x.mode.pulses, _x.mode.priority))
      length = len(self.mode.colors)
      buff.write(_struct_I.pack(length))
      for val1 in self.mode.colors:
        _x = val1
        buff.write(_get_struct_4f().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.mode.sequences)
      buff.write(_struct_I.pack(length))
      for val1 in self.mode.sequences:
        _v1 = val1.color
        _x = _v1
        buff.write(_get_struct_4f().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1
        buff.write(_get_struct_2f().pack(_x.hold_time, _x.cross_time))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.mode is None:
        self.mode = cob_light.msg.LightMode()
      end = 0
      _x = self
      start = end
      end += 14
      (_x.mode.mode, _x.mode.frequency, _x.mode.timeout, _x.mode.pulses, _x.mode.priority,) = _get_struct_B2fib().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mode.colors = []
      for i in range(0, length):
        val1 = std_msgs.msg.ColorRGBA()
        _x = val1
        start = end
        end += 16
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4f().unpack(str[start:end])
        self.mode.colors.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mode.sequences = []
      for i in range(0, length):
        val1 = cob_light.msg.Sequence()
        _v2 = val1.color
        _x = _v2
        start = end
        end += 16
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4f().unpack(str[start:end])
        _x = val1
        start = end
        end += 8
        (_x.hold_time, _x.cross_time,) = _get_struct_2f().unpack(str[start:end])
        self.mode.sequences.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_B2fib().pack(_x.mode.mode, _x.mode.frequency, _x.mode.timeout, _x.mode.pulses, _x.mode.priority))
      length = len(self.mode.colors)
      buff.write(_struct_I.pack(length))
      for val1 in self.mode.colors:
        _x = val1
        buff.write(_get_struct_4f().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.mode.sequences)
      buff.write(_struct_I.pack(length))
      for val1 in self.mode.sequences:
        _v3 = val1.color
        _x = _v3
        buff.write(_get_struct_4f().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1
        buff.write(_get_struct_2f().pack(_x.hold_time, _x.cross_time))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.mode is None:
        self.mode = cob_light.msg.LightMode()
      end = 0
      _x = self
      start = end
      end += 14
      (_x.mode.mode, _x.mode.frequency, _x.mode.timeout, _x.mode.pulses, _x.mode.priority,) = _get_struct_B2fib().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mode.colors = []
      for i in range(0, length):
        val1 = std_msgs.msg.ColorRGBA()
        _x = val1
        start = end
        end += 16
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4f().unpack(str[start:end])
        self.mode.colors.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mode.sequences = []
      for i in range(0, length):
        val1 = cob_light.msg.Sequence()
        _v4 = val1.color
        _x = _v4
        start = end
        end += 16
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4f().unpack(str[start:end])
        _x = val1
        start = end
        end += 8
        (_x.hold_time, _x.cross_time,) = _get_struct_2f().unpack(str[start:end])
        self.mode.sequences.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_4f = None
def _get_struct_4f():
    global _struct_4f
    if _struct_4f is None:
        _struct_4f = struct.Struct("<4f")
    return _struct_4f
_struct_B2fib = None
def _get_struct_B2fib():
    global _struct_B2fib
    if _struct_B2fib is None:
        _struct_B2fib = struct.Struct("<B2fib")
    return _struct_B2fib
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from cob_light/SetLightModeResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SetLightModeResponse(genpy.Message):
  _md5sum = "44b6bbe013cafd2810aef2660066a5b8"
  _type = "cob_light/SetLightModeResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint8 active_mode
uint8 active_priority
uint64 track_id

"""
  __slots__ = ['active_mode','active_priority','track_id']
  _slot_types = ['uint8','uint8','uint64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       active_mode,active_priority,track_id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SetLightModeResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.active_mode is None:
        self.active_mode = 0
      if self.active_priority is None:
        self.active_priority = 0
      if self.track_id is None:
        self.track_id = 0
    else:
      self.active_mode = 0
      self.active_priority = 0
      self.track_id = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2BQ().pack(_x.active_mode, _x.active_priority, _x.track_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 10
      (_x.active_mode, _x.active_priority, _x.track_id,) = _get_struct_2BQ().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2BQ().pack(_x.active_mode, _x.active_priority, _x.track_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 10
      (_x.active_mode, _x.active_priority, _x.track_id,) = _get_struct_2BQ().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2BQ = None
def _get_struct_2BQ():
    global _struct_2BQ
    if _struct_2BQ is None:
        _struct_2BQ = struct.Struct("<2BQ")
    return _struct_2BQ
class SetLightMode(object):
  _type          = 'cob_light/SetLightMode'
  _md5sum = 'f950166d97058c12e842261aa35075dd'
  _request_class  = SetLightModeRequest
  _response_class = SetLightModeResponse
