// Auto-generated. Do not edit!

// (in-package cob_light.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Sequence = require('./Sequence.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class LightMode {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.mode = null;
      this.frequency = null;
      this.timeout = null;
      this.pulses = null;
      this.priority = null;
      this.colors = null;
      this.sequences = null;
    }
    else {
      if (initObj.hasOwnProperty('mode')) {
        this.mode = initObj.mode
      }
      else {
        this.mode = 0;
      }
      if (initObj.hasOwnProperty('frequency')) {
        this.frequency = initObj.frequency
      }
      else {
        this.frequency = 0.0;
      }
      if (initObj.hasOwnProperty('timeout')) {
        this.timeout = initObj.timeout
      }
      else {
        this.timeout = 0.0;
      }
      if (initObj.hasOwnProperty('pulses')) {
        this.pulses = initObj.pulses
      }
      else {
        this.pulses = 0;
      }
      if (initObj.hasOwnProperty('priority')) {
        this.priority = initObj.priority
      }
      else {
        this.priority = 0;
      }
      if (initObj.hasOwnProperty('colors')) {
        this.colors = initObj.colors
      }
      else {
        this.colors = [];
      }
      if (initObj.hasOwnProperty('sequences')) {
        this.sequences = initObj.sequences
      }
      else {
        this.sequences = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type LightMode
    // Serialize message field [mode]
    bufferOffset = _serializer.uint8(obj.mode, buffer, bufferOffset);
    // Serialize message field [frequency]
    bufferOffset = _serializer.float32(obj.frequency, buffer, bufferOffset);
    // Serialize message field [timeout]
    bufferOffset = _serializer.float32(obj.timeout, buffer, bufferOffset);
    // Serialize message field [pulses]
    bufferOffset = _serializer.int32(obj.pulses, buffer, bufferOffset);
    // Serialize message field [priority]
    bufferOffset = _serializer.int8(obj.priority, buffer, bufferOffset);
    // Serialize message field [colors]
    // Serialize the length for message field [colors]
    bufferOffset = _serializer.uint32(obj.colors.length, buffer, bufferOffset);
    obj.colors.forEach((val) => {
      bufferOffset = std_msgs.msg.ColorRGBA.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [sequences]
    // Serialize the length for message field [sequences]
    bufferOffset = _serializer.uint32(obj.sequences.length, buffer, bufferOffset);
    obj.sequences.forEach((val) => {
      bufferOffset = Sequence.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type LightMode
    let len;
    let data = new LightMode(null);
    // Deserialize message field [mode]
    data.mode = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [frequency]
    data.frequency = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [timeout]
    data.timeout = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [pulses]
    data.pulses = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [priority]
    data.priority = _deserializer.int8(buffer, bufferOffset);
    // Deserialize message field [colors]
    // Deserialize array length for message field [colors]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.colors = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.colors[i] = std_msgs.msg.ColorRGBA.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [sequences]
    // Deserialize array length for message field [sequences]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.sequences = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.sequences[i] = Sequence.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += 16 * object.colors.length;
    length += 24 * object.sequences.length;
    return length + 22;
  }

  static datatype() {
    // Returns string type for a message object
    return 'cob_light/LightMode';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '7aecb45b0da2ee8d387f2bec4ee2faf9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    uint8 mode                         # mode to switch on
    
    float32                frequency   # in Hz
    float32                timeout     # in s, requested mode will be executed for max timeout s.
                                       # default is 0 and means no timeout.
    int32                  pulses      # specifies the amount of pulses which will be executed.
                                       # eg: mode = flash, pulses = 2. Means the light will flash two times
    int8                   priority    # priority [-20,20] default = 0. Modes with same or higher priorities will
                                       # be executed.
    std_msgs/ColorRGBA[]   colors      # array of colors.
                                       # size > 1: each color represent one led (size should match the amount of leds)
                                       # size = 1: one color for all leds or color for specific mode
                                       # size = 0: undefined
    cob_light/Sequence[]   sequences   # an array of sequence definitions, used only if mode is set to SEQ
    
    ================================================================================
    MSG: std_msgs/ColorRGBA
    float32 r
    float32 g
    float32 b
    float32 a
    
    ================================================================================
    MSG: cob_light/Sequence
    std_msgs/ColorRGBA   color       #sequence color
    float32              hold_time   #time how long the color should be hold [s]
    float32              cross_time  #time how long it take to fade to this color [s]
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new LightMode(null);
    if (msg.mode !== undefined) {
      resolved.mode = msg.mode;
    }
    else {
      resolved.mode = 0
    }

    if (msg.frequency !== undefined) {
      resolved.frequency = msg.frequency;
    }
    else {
      resolved.frequency = 0.0
    }

    if (msg.timeout !== undefined) {
      resolved.timeout = msg.timeout;
    }
    else {
      resolved.timeout = 0.0
    }

    if (msg.pulses !== undefined) {
      resolved.pulses = msg.pulses;
    }
    else {
      resolved.pulses = 0
    }

    if (msg.priority !== undefined) {
      resolved.priority = msg.priority;
    }
    else {
      resolved.priority = 0
    }

    if (msg.colors !== undefined) {
      resolved.colors = new Array(msg.colors.length);
      for (let i = 0; i < resolved.colors.length; ++i) {
        resolved.colors[i] = std_msgs.msg.ColorRGBA.Resolve(msg.colors[i]);
      }
    }
    else {
      resolved.colors = []
    }

    if (msg.sequences !== undefined) {
      resolved.sequences = new Array(msg.sequences.length);
      for (let i = 0; i < resolved.sequences.length; ++i) {
        resolved.sequences[i] = Sequence.Resolve(msg.sequences[i]);
      }
    }
    else {
      resolved.sequences = []
    }

    return resolved;
    }
};

module.exports = LightMode;
